         PROGRAM FLOWM
C THIS PROGRAM CALCULATES RADIATION TRANSFER THROUGH A DUST SHELL
        DOUBLE PRECISION AIPLUS
        COMMON/INTRG/  II,III,NFREQ
        COMMON/REAL3/ ABH,ABHE,EL
        COMMON/PHREQ/ NF,FREQ(150),WF(150)
        COMMON/CONSTS/ SIG1,C,PI
        COMMON/FCTRS/FHJ,FKJ(200),CHIJ(200),CHIF(200),QSP(200),CHFT(200)
        COMMON/ATMSP/ TEMP(200),DENST(200)
        COMMON/CASES/ ITER,NTCREK
        COMMON/REAL/ HZORSQ,TEFF
        COMMON/OPTDEP/ TAUZ(200),CAPZER
        COMMON/FRAC/ P(200),R(300),NR,NP,INDEX(200)
        COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
        COMMON/ARE/REFF
        COMMON/CORE/STRMS,STARL
        COMMON/CONT/AIPLUS(150,200),AIMPCT(200)
        COMMON/SILICATE/AS(25),YC1(25),YSI1(25)
        COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),
     1         DTEMP(2,25,200),DPLNK(2,25,200),DCHIJ(2,25,200)
        COMMON/STRH/STRFLDN(150)
C   control for ice mantles  (DOSW 7/27/87)
        COMMON/DUST6/MANTLES,RMANTLE,TICE
        CHARACTER*15 directory
	LOGICAL MANTLES
        DIMENSION AIPLSI(150,200),AIPNU(150)
c        call nonstandard_arithmetic()
c       idummy = ieee_handler('set','undeflow',SIGFPE_ABORT)
c       idummy = ieee_handler('set','invalid',%val(2))
C  NF     = #FREQ USED IN IN OPAC
C  NFREQ  = #FREQ USED IN TRANSFER.   FOR GREY, NFREQ=1
C  NTCREK = MAXIMUM NUMBER OF TEMPERATURE CORRECTIONS
C  STRMS  = STAR MASS
C  TEFF   = STELLAR EFFECTIVE TEMPERTURE
C  RSTAR  = STELLAR RADIUS
C  ABH    = NUMBER FRACTION OF HYDROGEN
C  ABHE   = NUMBER FRACTION OF HELIUM
c        OPEN(UNIT=12,STATUS='OLD',FILE='directory.dat')
C  FLOWSUM.OUT was added by DOSW to be a summary of the output produced
C for use in plotting, etc.
c        READ(12,990)DIRECTORY
 990    FORMAT(A15)
        OPEN(UNIT=10,STATUS='OLD',FILE='flowpart.dat')
c        OPEN(UNIT=11,STATUS='UNKNOWN',FILE=DIRECTORY//'/flowout.dat')
c	OPEN(UNIT=21,STATUS='UNKNOWN',FILE=DIRECTORY//'/fnew.out')
c        OPEN(UNIT=22,STATUS='UNKNOWN',FILE=DIRECTORY//'/rfp.dat')
c        OPEN(UNIT=23,STATUS='UNKNOWN',FILE=DIRECTORY//'/head.out')
c        OPEN(UNIT=24,STATUS='UNKNOWN',FILE=DIRECTORY//'/rot.out')
c        OPEN(UNIT=25,STATUS='UNKNOWN',FILE=DIRECTORY//'/dtg.out')
c        OPEN(UNIT=26,STATUS='UNKNOWN',FILE=DIRECTORY//'/dtsi.out')
        OPEN(UNIT=11,STATUS='UNKNOWN',FILE='flowout.dat')
	OPEN(UNIT=21,STATUS='UNKNOWN',FILE='fnew.out')
        OPEN(UNIT=22,STATUS='UNKNOWN',FILE='rfp.dat')
        OPEN(UNIT=23,STATUS='UNKNOWN',FILE='head.out')
        OPEN(UNIT=24,STATUS='UNKNOWN',FILE='rot.out')
        OPEN(UNIT=25,STATUS='UNKNOWN',FILE='dtg.out')
        OPEN(UNIT=28,STATUS='UNKNOWN',FILE='fnews.out')
        OPEN(UNIT=29,STATUS='UNKNOWN',FILE='totmod.out')
        READ(10,*)NF,NFREQ,NTCREK
        WRITE(11,1000)NF,NFREQ,NTCREK
	WRITE(23,1000)NF,NFREQ,NTCREK
 1000   FORMAT('NF = ',I5/'NFREQ = ',I5/'NTCREK = ',I5)
        READ(10,*)STRMS,TEFF,RSTAR,ABH,ABHE
        WRITE(11,1001)STRMS,TEFF,RSTAR,ABH,ABHE
	WRITE(23,1001)STRMS,TEFF,RSTAR,ABH,ABHE
 1001   FORMAT('STRMS = ',E12.4/'TEFF = ',E12.4/'RSTAR = ',
     .          E12.4/'ABH = ',E12.4/'ABHE = ',E12.4)
C
C  READ IN GRAIN PARAMETERS
        CALL READIN
C
        PI=3.1415926
        C=2.997925E+10
        SUNL=3.826E+33
        SIG1=5.66956E-5
        CAPZER = 1.0
        WRITE(11,9004) (WF(I),I=1,NF)
9004    FORMAT(' WF ',/,(3E15.7))
        STARL = 4.0*PI*SIG1*(RSTAR**2)*((TEFF**4)/SUNL)

C   READ IN RADIAL GRID OF TEMP AND DENSITY
        CALL READRO(R,TEMP,DENST)

C   Done with the inputs so close FLOWPAR.DAT:
        CLOSE (10)

C---------------------  dosw
	WRITE(11,*) 'R,TEMP AND DENSITY GRID USED IN THE CALCUATION:'
	WRITE(11,*) '     R             TEMP          DENSITY'
	WRITE(11,9876) (R(I),TEMP(I),DENST(I),I=1,III)
9876	FORMAT(' ',3E15.7)

        NR=III
C  INITILIZE H/J = 0.5
        FHJ=0.5
        ITER = 1
        DEL = 0.0
        AHRSQ=0.0
        HZORSQ = (TEFF**4)*SIG1/(4.*PI)
        HZORSQ = HZORSQ*((RSTAR/R(1))**2)
        WRITE(6,*)'RSTAR,REFF,HZORSQ',RSTAR,REFF,HZORSQ
C
C  HZORSQ=((RSQ H)/R1**2) i.e. IT IS THE VALUE OF H(totel) AT THE
C  INNER BOUNDARY
C
        CALL RADTRN

c  ------   dosw
c  Write the final model tempreature and density results to the summary
C  file
C Modified to write output in program flowmout (flowm2.f,sphrset2.f,radtrn2.f)
c	WRITE(24,*) '    R        T     Density'
c	WRITE(24,*) ' NUMERIC NUMERIC NUMERIC '
c        WRITE(24,*) ' [cm]  [K]  [gm/cm3] '
c	DO 100 JJJ = 1,III,2
c	   WRITE(24,5901) R(JJJ),TEMP(JJJ),DENST(JJJ)
c5901	   FORMAT(' ',3(1PE10.3))
c 100    CONTINUE
c        NU2P2 = 59
c        NU4P8 = 49
c        NU10P5 = 33
c        NU12 = 28
c       NU25 = 19
c        NU60 = 15
c        NU100 = 13
c        NU158 = 11
c        FRE350 = C*1.0E4/350.0
c        FRE450 = C*1.0E4/450.0
c        FRE610 = C*1.0E4/610.0
c        FRE800 = C*1.0E4/800.0
c        NU794 = 4
c        NU1000 = 3
c        FRE1300= C*1.0E4/1300.0
c        FRE2600= C*1.0E4/2600.0
C Convert stellar flux H(R_III) to stellar intensity I(R_III)
c        DO 102 INU = 1,NF
c        STRFLDN(INU) = STRFLDN(INU)*4.0*(R(III)/REFF)**2
102    CONTINUE
c        DO 104 IP=1, NP+6
c        DO 103 INU=1,NF
c           AIPNU(INU)=AIPLUS(INU,IP)
c 103    CONTINUE
c        CALL INTERP (FREQ, AIPNU, NF, 2,FRE450, YOUT)
c        AIPLSI(1,IP)=YOUT
c        CALL INTERP (FREQ, AIPNU, NF, 2,FRE610, YOUT)
c        AIPLSI(2,IP)=YOUT
c        CALL INTERP (FREQ, AIPNU, NF, 2,FRE800, YOUT)
c        AIPLSI(3,IP)=YOUT
c        CALL INTERP (FREQ, AIPNU, NF, 2,FRE1300, YOUT)
c        AIPLSI(4,IP)=YOUT
c        CALL INTERP (FREQ, AIPNU, NF, 2,FRE2600, YOUT)
c        AIPLSI(5,IP)=YOUT
c 104    CONTINUE
c        CALL INTERP (FREQ, STRFLDN, NF, 2,FRE450, YOUT)
c        AJYS450=YOUT
c        CALL INTERP (FREQ, STRFLDN, NF, 2,FRE610, YOUT)
c        AJYS610=YOUT
c        CALL INTERP (FREQ, STRFLDN, NF, 2,FRE800, YOUT)
c        AJYS800=YOUT
c        CALL INTERP (FREQ, STRFLDN, NF, 2,FRE1300, YOUT)
c        AJYS1300=YOUT
c        CALL INTERP (FREQ, STRFLDN, NF, 2,FRE2600, YOUT)
c        AJYS2600=YOUT
C Write out stellar intensity I(R_III) and stellar radius
c        AIMPCT(1)=REFF
c        WRITE(28,5903)AIMPCT(1),STRFLDN(NU2P2),STRFLDN(NU4P8),
c     .    STRFLDN(NU10P5),STRFLDN(NU12),STRFLDN(NU25),
c     .    STRFLDN(NU60),STRFLDN(NU100),STRFLDN(NU158),
c     .    AJYS450,AJYS610,AJYS800,AJYS1300,AJYS2600
C Write out I+ p = 0.0 (shell only)
c        IP = 1
c        WRITE(28,5903)AIMPCT(IP),AIPLUS(NU2P2,IP),AIPLUS(NU4P8,IP),
c     .    AIPLUS(NU10P5,IP),AIPLUS(NU12,IP),AIPLUS(NU25,IP),
c     .    AIPLUS(NU60,IP),AIPLUS(NU100,IP),AIPLUS(NU158,IP),
c     .    AIPLSI(1,IP),AIPLSI(2,IP),AIPLSI(3,IP),
c     .    AIPLSI(4,IP),AIPLSI(5,IP)
C ADD Stellar intensity I(R_III) to I+
c        NPT = NP+6
c        DO 105 INU=1,NF
c          AIPLUS(INU,1) = AIPLUS(INU,1)+STRFLDN(INU)
c 105    CONTINUE
c        AIPLSI(1,1) = AIPLSI(1,1)+AJYS450
c        AIPLSI(2,1) = AIPLSI(2,1)+AJYS610
c        AIPLSI(3,1) = AIPLSI(3,1)+AJYS800
c        AIPLSI(4,1) = AIPLSI(4,1)+AJYS1300
c        AIPLSI(5,1) = AIPLSI(5,1)+AJYS2600
c        WRITE(22,*)'p I I I I I I I I I I I I I'
c        WRITE(22,*)'NUMERIC NUMERIC NUMERIC NUMERIC 
c     .  NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC
c     .  NUMERIC NUMERIC NUMERIC NUMERIC'
c        WRITE(22,*)'[cm] [2.2um] [4.8um] [10.5um] [12um] [25um]
c     . [60um] [100um] [158um] [450um] [610um] [800um]
c     . [1.3mm] [2.6mm] '
c        DO 106 IP=1,NPT-1
c        WRITE(22,5903)AIMPCT(IP),AIPLUS(NU2P2,IP),AIPLUS(NU4P8,IP),
c     .    AIPLUS(NU10P5,IP),AIPLUS(NU12,IP),AIPLUS(NU25,IP),
c     .    AIPLUS(NU60,IP),AIPLUS(NU100,IP),AIPLUS(NU158,IP),
c     .    AIPLSI(1,IP),AIPLSI(2,IP),AIPLSI(3,IP),
c     .    AIPLSI(4,IP),AIPLSI(5,IP)
c 106    CONTINUE
c        IP = NPT-1
c        WRITE(22,5903)AIMPCT(IP+1),AIPLUS(NU2P2,IP),AIPLUS(NU4P8,IP),
c     .    AIPLUS(NU10P5,IP),AIPLUS(NU12,IP),AIPLUS(NU25,IP),
c     .    AIPLUS(NU60,IP),AIPLUS(NU100,IP),AIPLUS(NU158,IP),
c     .    AIPLSI(1,IP),AIPLSI(2,IP),AIPLSI(3,IP),
c     .    AIPLSI(4,IP),AIPLSI(5,IP)
5903    FORMAT(' ',14(1PE10.3))
        WRITE(29,*)III
        DO 107 I=1,III
        WRITE(29,5904)R(I),TEMP(I),(DTEMP(1,IA,I),IA=1,25)
 107    CONTINUE
        DO 108 I=1,III
        WRITE(29,5905)(DTEMP(2,IA,I),IA=1,25)
 108    CONTINUE
 5904   FORMAT((1PE12.5),26(1PE9.2))
c 5904   FORMAT(27(1PE12.5))
c 5905   FORMAT(25(1PE12.5))
 5905   FORMAT(25(1PE9.2))
	CLOSE(21)
        CLOSE(22)
        CLOSE(23)
        CLOSE(29)
c ------ dosw

        STOP
        END
