         PROGRAM FLOWM
C THIS PROGRAM CALCULATES RADIATION TRANSFER THROUGH A DUST SHELL
C VERSION MODIFIED FOR OUTPUT
        DOUBLE PRECISION AIPLUS
        COMMON/INTRG/  II,III,NFREQ
        COMMON/REAL3/ ABH,ABHE,EL
        COMMON/PHREQ/ NF,FREQ(150),WF(150)
        COMMON/CONSTS/ SIG1,C,PI
        COMMON/FCTRS/FHJTOT,FKJTOT(200),CHIJ(200),CHIF(200),
     1         QSPTOT(200),CHFT(200)
        COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     A              QSP(150,200),HHNU(150)
        COMMON/ATMSP/ TEMP(200),DENST(200)
        COMMON/CASES/ ITER,NTCREK
        COMMON/REAL/ HZORSQ,TEFF
        COMMON/OPTDEP/ TAUZ(200),CAPZER
        COMMON/FRAC/ P(200),R(300),NR,NP,INDEX(200)
        COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
        COMMON/ARE/REFF
        COMMON/CORE/STRMS,STARL
        COMMON/CONT/AIPLUS(150,200),AIMPCT(200)
        COMMON/SILICATE/AS(25),YC1(25),YSI1(25)
        COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),
     1    DTEMP(2,25,200),DPLNK(2,25,200),DCHIJ(2,25,200)
        COMMON/STRH/STRFLDN(150)
        COMMON/MEANER/TRAD(200)
C   control for ice mantles  (DOSW 7/27/87)
        COMMON/DUST6/MANTLES,RMANTLE,TICE
        CHARACTER*15 directory
	LOGICAL MANTLES
        DIMENSION AIPLSI(150,200),AIPNU(150),AHTOT(150)
        DIMENSION FREQL(150),AHTOTL(150),AIPNUL(150),STRFLDL(150)
c        call nonstandard_arithmetic()
c       idummy = ieee_handler('set','undeflow',SIGFPE_ABORT)
c       idummy = ieee_handler('set','invalid',%val(2))
C  NF     = #FREQ USED IN IN OPAC
C  NFREQ  = #FREQ USED IN TRANSFER.   FOR GREY, NFREQ=1
C  NTCREK = MAXIMUM NUMBER OF TEMPERATURE CORRECTIONS
C  STRMS  = STAR MASS
C  TEFF   = STELLAR EFFECTIVE TEMPERTURE
C  RSTAR  = STELLAR RADIUS
C  ABH    = NUMBER FRACTION OF HYDROGEN
C  ABHE   = NUMBER FRACTION OF HELIUM
c        OPEN(UNIT=12,STATUS='OLD',FILE='directory.dat')
C  FLOWSUM.OUT was added by DOSW to be a summary of the output produced
C for use in plotting, etc.
c        READ(12,990)DIRECTORY
 990    FORMAT(A15)
        OPEN(UNIT=10,STATUS='OLD',FILE='flowpart.dat')
c        OPEN(UNIT=11,STATUS='UNKNOWN',FILE=DIRECTORY//'/flowout.dat')
c	OPEN(UNIT=21,STATUS='UNKNOWN',FILE=DIRECTORY//'/fnew.out')
c        OPEN(UNIT=22,STATUS='UNKNOWN',FILE=DIRECTORY//'/rfp.dat')
c        OPEN(UNIT=23,STATUS='UNKNOWN',FILE=DIRECTORY//'/head.out')
c        OPEN(UNIT=24,STATUS='UNKNOWN',FILE=DIRECTORY//'/rot.out')
c        OPEN(UNIT=25,STATUS='UNKNOWN',FILE=DIRECTORY//'/dtg.out')
c        OPEN(UNIT=26,STATUS='UNKNOWN',FILE=DIRECTORY//'/dtsi.out')
        OPEN(UNIT=11,STATUS='UNKNOWN',FILE='flowout.dat')
	OPEN(UNIT=21,STATUS='UNKNOWN',FILE='fnew.out')
        OPEN(UNIT=22,STATUS='UNKNOWN',FILE='rfptot.dat')
        OPEN(UNIT=23,STATUS='UNKNOWN',FILE='head.out')
        OPEN(UNIT=24,STATUS='UNKNOWN',FILE='rot.out')
        OPEN(UNIT=25,STATUS='UNKNOWN',FILE='dtg.out')
        OPEN(UNIT=28,STATUS='UNKNOWN',FILE='fnews.out')
        OPEN(UNIT=31,STATUS='UNKNOWN',FILE='rfpallf.dat')
        OPEN(UNIT=32,STATUS='UNKNOWN',FILE='fnewsallf.out')
        OPEN(UNIT=33,STATUS='UNKNOWN',FILE='fnewnet.out')
c        OPEN(UNIT=29,STATUS='UNKNOWN',FILE='totmod.out')
        READ(10,*)NF,NFREQ,NTCREK
        WRITE(11,1000)NF,NFREQ,NTCREK
	WRITE(23,1000)NF,NFREQ,NTCREK
 1000   FORMAT('NF = ',I5/'NFREQ = ',I5/'NTCREK = ',I5)
        READ(10,*)STRMS,TEFF,RSTAR,ABH,ABHE
        WRITE(11,1001)STRMS,TEFF,RSTAR,ABH,ABHE
	WRITE(23,1001)STRMS,TEFF,RSTAR,ABH,ABHE
 1001   FORMAT('STRMS = ',E12.4/'TEFF = ',E12.4/'RSTAR = ',
     .          E12.4/'ABH = ',E12.4/'ABHE = ',E12.4)
C
C  READ IN GRAIN PARAMETERS
        CALL READIN
C
        PI=3.1415926
        C=2.997925E+10
        SUNL=3.826E+33
        SIG1=5.66956E-5
        CAPZER = 1.0
        WRITE(11,9004) (WF(I),I=1,NF)
9004    FORMAT(' WF ',/,(3E15.7))
        STARL = 4.0*PI*SIG1*(RSTAR**2)*((TEFF**4)/SUNL)

C   READ IN RADIAL GRID OF TEMP AND DENSITY
        CALL READRO(R,TEMP,DENST)

C   Done with the inputs so close FLOWPAR.DAT:
        CLOSE (10)

C---------------------  dosw
	WRITE(11,*) 'R,TEMP AND DENSITY GRID USED IN THE CALCUATION:'
	WRITE(11,*) '     R             TEMP          DENSITY'
	WRITE(11,9876) (R(I),TEMP(I),DENST(I),I=1,III)
9876	FORMAT(' ',3E15.7)

        NR=III
C  INITILIZE H/J = 0.5
        FHJTOT=0.5
        ITER = 1
        DEL = 0.0
        AHRSQ=0.0
        HZORSQ = (TEFF**4)*SIG1/(4.*PI)
        HZORSQ = HZORSQ*((RSTAR/R(1))**2)
        WRITE(6,*)'RSTAR,REFF,HZORSQ',RSTAR,REFF,HZORSQ
C
C  HZORSQ=((RSQ H)/R1**2) i.e. IT IS THE VALUE OF H(totel) AT THE
C  INNER BOUNDARY
C
        CALL RADTRN

c  ------   dosw
c  Write the final model tempreature and density results to the summary
C  file
C before radtrn TEMP is the mean Silicate temperature
C after radtrn TEMP is the area averaged mean temperature calculated 
C in radtrn2->meant
	WRITE(24,*) '    R   T_gas  Density   T_rad '
	WRITE(24,*) ' NUMERIC NUMERIC NUMERIC NUMERIC'
        WRITE(24,*) ' [cm]  [K]  [gm/cm3] [K]'
	DO 100 JJJ = 1,III,5
	   WRITE(24,5901) R(JJJ),TEMP(JJJ),DENST(JJJ),TRAD(JJJ)
5901	   FORMAT(' ',4(1PE10.3))
 100    CONTINUE
        NU2P2 = 69
        FRE3P6 = C*1.0E4/3.6
        NU4P8 = 57
        FRE5P8 = C*1.0E4/5.8
        FRE8P0 = C*1.0E4/8.0
        NU9P7 = 43
        NU10P5 = 39
        NU12 = 34
        NU14P2 = 32
        FRE19 = C*1.0E4/19.0
        NU25 = 25
        NU60 = 21
        NU100 = 17
        NU158 = 13
        NU200 = 11
        FRE370 = C*1.0E4/370.0
        FRE450 = C*1.0E4/450.0
        FRE610 = C*1.0E4/610.0
        FRE800 = C*1.0E4/800.0
        NU794 = 4
        NU1000 = 3
        FRE1300= C*1.0E4/1300.0
        FRE2600= C*1.0E4/2600.0
C Convert stellar flux H(R_III) to stellar intensity I(R_III)
        DO 102 INU = 1,NF
           STRFLDN(INU) = STRFLDN(INU)*4.0*(R(III)/REFF)**2
     .                   + 1.0e-32
           STRFLDL(INU) = ALOG10(STRFLDN(INU))
C Conver Eddington H to net Flux (H+ - H-) emitted at shell surface
           AHTOT(INU)   = 4.0*PI*(XHNU(INU,III))
           AHTOT(INU) = MAX(AHTOT(INU),1.0e-28)
           FREQL(INU) = ALOG10(FREQ(INU))
           AHTOTL(INU) = ALOG10(ABS(AHTOT(INU)))
102    CONTINUE
        DO 104 IP=1, NP+6
        DO 103 INU=1,NF
           AIPNU(INU)=AIPLUS(INU,IP)
           AIPNUL(INU) = DLOG10(DABS(AIPLUS(INU,IP)))
 103    CONTINUE
C INTERPOLATE SHELL INTENSITIES
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE3P6), YOUT)
        AIPLSI(1,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE5P8), YOUT)
        AIPLSI(2,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE8P0), YOUT)
        AIPLSI(3,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE19), YOUT)
        AIPLSI(4,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE370), YOUT)
        AIPLSI(5,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE450), YOUT)
        AIPLSI(6,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE610), YOUT)
        AIPLSI(7,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE800), YOUT)
        AIPLSI(8,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE1300), YOUT)
        AIPLSI(9,IP)=10.00**YOUT
        CALL INTERP (FREQL, AIPNUL, NF, 2,ALOG10(FRE2600), YOUT)
        AIPLSI(10,IP)=10.00**YOUT
 104    CONTINUE
C INTERPOLATE STELLAR CONTRIBUTION (ALONE)
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE3P6), YOUT)
        AJYS3P6=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE5P8), YOUT)
        AJYS5P8=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE8P0), YOUT)
        AJYS8P0=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE19), YOUT)
        AJYS19=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE370), YOUT)
        AJYS370=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE450), YOUT)
        AJYS450=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE610), YOUT)
        AJYS610=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE800), YOUT)
        AJYS800=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE1300), YOUT)
        AJYS1300=10.00**YOUT
        CALL INTERP (FREQL, STRFLDL, NF, 2,ALOG10(FRE2600), YOUT)
        AJYS2600=10.00**YOUT
C INTERPOLATE NET (H+ - H-) FLUX
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE3P6), YOUT)
        AHT3P6=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE5P8), YOUT)
        AHT5P8=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE8P0), YOUT)
        AHT8P0=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE19), YOUT)
        AHT19=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE370), YOUT)
        AHT370=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE450), YOUT)
        AHT450=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE610), YOUT)
        AHT610=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE800), YOUT)
        AHT800=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE1300), YOUT)
        AHT1300=10.00**YOUT
        CALL INTERP (FREQL, AHTOTL, NF, 2,ALOG10(FRE2600), YOUT)
        AHT2600=10.00**YOUT
C Write out stellar intensity I(R_III) and stellar radius
        AIMPCT(1)=REFF
        WRITE(28,5903)AIMPCT(1),STRFLDN(NU2P2),AJYS3P6,
     .    STRFLDN(NU4P8),AJYS5P8,AJYS8P0,STRFLDN(NU9P7),
     .    STRFLDN(NU12),STRFLDN(NU14P2),AJYS19,STRFLDN(NU25),
     .    STRFLDN(NU60),STRFLDN(NU100),STRFLDN(NU158),
     .    STRFLDN(NU200),AJYS370,AJYS450,AJYS610,AJYS800,
     .    STRFLDN(NU1000),AJYS1300,AJYS2600
        WRITE(32,5905)AIMPCT(1),(STRFLDN(NU),NU=1,NF)
C Write out (I+ - I-) p = 0.0 (shell only)
        IP = 1
        WRITE(28,5903)AIMPCT(IP),AIPLUS(NU2P2,IP),AIPLSI(1,IP),
     .    AIPLUS(NU4P8,IP),AIPLSI(2,IP),AIPLSI(3,IP),
     .    AIPLUS(NU9P7,IP),AIPLUS(NU12,IP),AIPLUS(NU14P2,IP),
     .    AIPLSI(4,IP),AIPLUS(NU25,IP), AIPLUS(NU60,IP),
     .    AIPLUS(NU100,IP),AIPLUS(NU158,IP),AIPLUS(NU200,IP),
     .    AIPLSI(5,IP),AIPLSI(6,IP),AIPLSI(7,IP),
     .    AIPLSI(8,IP),AIPLUS(NU1000,IP),AIPLSI(9,IP),
     .    AIPLSI(10,IP)
        WRITE(32,5905)AIMPCT(IP),(AIPLUS(NU,IP),NU=1,NF)
C Write out TOTAL FLUX
        WRITE(28,5903)AIMPCT(1),AHTOT(NU2P2),AHT3P6,
     .    AHTOT(NU4P8),AHT5P8,AHT8P0,AHTOT(NU9P7),
     .    AHTOT(NU12),AHTOT(NU14P2),AHT19,AHTOT(NU25),
     .    AHTOT(NU60),AHTOT(NU100),AHTOT(NU158),
     .    AHTOT(NU200),AHT370,AHT450,AHT610,AHT800,
     .    AHTOT(NU1000),AHT1300,AHT2600
        WRITE(32,5905)AIMPCT(1),(AHTOT(NU),NU=1,NF)
C Write out Freqeucy array
        WRITE(32,5906)(FREQ(NU),NU=1,NF)
C ADD Stellar intensity I(R_III) to I+ - I-
        NPT = NP+6
        DO 105 INU=1,NF
          AIPLUS(INU,1) = AIPLUS(INU,1)+STRFLDN(INU)
 105    CONTINUE
        AIPLSI(1,1) = AIPLSI(1,1)+AJYS3P6
        AIPLSI(2,1) = AIPLSI(2,1)+AJYS5P5
        AIPLSI(3,1) = AIPLSI(3,1)+AJYS8P0
        AIPLSI(4,1) = AIPLSI(4,1)+AJYS19
        AIPLSI(5,1) = AIPLSI(5,1)+AJYS370
        AIPLSI(6,1) = AIPLSI(6,1)+AJYS450
        AIPLSI(7,1) = AIPLSI(7,1)+AJYS610
        AIPLSI(8,1) = AIPLSI(8,1)+AJYS800
        AIPLSI(9,1) = AIPLSI(9,1)+AJYS1300
        AIPLSI(10,1) = AIPLSI(10,1)+AJYS2600
        WRITE(22,*)NPT
        WRITE(31,*)NPT
        WRITE(22,*)'p I I I I I I I I I I I I I I I I I I I I I'
        WRITE(22,*)'NUMERIC NUMERIC NUMERIC NUMERIC 
     .  NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC
     .  NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC
     .  NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC'
        WRITE(22,*)'[cm] [2.2um] [3.6um] [4.8um] [5.8um] [8.0um] 
     . [9.7um] [12um] [14.2] [19um] [25um] [60um] [100um] [158um] 
     . [200um] [370um] [450um] [610um] [800um] [1.0mm] [1.3mm] [2.6mm] '
        DO 106 IP=1,NPT-1
c        DO 106 IP=1,NPT
C Write out Stellar plus shell intensities I+ - I- (all impact parameters)
        WRITE(22,5903)AIMPCT(IP),AIPLUS(NU2P2,IP),AIPLSI(1,IP),
     .    AIPLUS(NU4P8,IP),AIPLSI(2,IP),AIPLSI(3,IP),
     .    AIPLUS(NU9P7,IP),AIPLUS(NU12,IP),AIPLUS(NU14P2,IP),
     .    AIPLSI(4,IP),AIPLUS(NU25,IP), AIPLUS(NU60,IP),
     .    AIPLUS(NU100,IP),AIPLUS(NU158,IP),AIPLUS(NU200,IP),
     .    AIPLSI(5,IP),AIPLSI(6,IP),AIPLSI(7,IP),
     .    AIPLSI(8,IP),AIPLUS(NU1000,IP),AIPLSI(9,IP),
     .    AIPLSI(10,IP)
C Write out all stellar plus shell intensities at all frequencies for use in 
C instrument interpolations
        WRITE(31,5905)AIMPCT(IP),(AIPLUS(NU,IP),NU=1,NF)
 106    CONTINUE
C for last shell write stellar plus shell intensities at III-1
C Intensties at III = 0
        IP = NPT-1
        WRITE(22,5903)AIMPCT(IP+1),AIPLUS(NU2P2,IP),AIPLSI(1,IP),
     .    AIPLUS(NU4P8,IP),AIPLSI(2,IP),AIPLSI(3,IP),
     .    AIPLUS(NU9P7,IP),AIPLUS(NU12,IP),AIPLUS(NU14P2,IP),
     .    AIPLSI(4,IP),AIPLUS(NU25,IP), AIPLUS(NU60,IP),
     .    AIPLUS(NU100,IP),AIPLUS(NU158,IP),AIPLUS(NU200,IP),
     .    AIPLSI(5,IP),AIPLSI(6,IP),AIPLSI(7,IP),
     .    AIPLSI(8,IP),AIPLUS(NU1000,IP),AIPLSI(9,IP),
     .    AIPLSI(10,IP)
C Write out all frequencies for use in instrument interpolations
        WRITE(31,5905)AIMPCT(IP+1),(AIPLUS(NU,IP),NU=1,NF)
5903    FORMAT(' ',22(1PE10.3))
5905    FORMAT(' ',84(1PE10.3))
 5906   FORMAT(' ',83(1PE10.3))
c        WRITE(29,*)III
c        DO 107 I=1,III
c        WRITE(29,5904)R(I),TEMP(I),DENST(I),(DTEMP(1,IA,I),IA=1,25)
c 107    CONTINUE
c        DO 108 I=1,III
c        WRITE(29,5905)(DTEMP(2,IA,I),IA=1,25)
c 108    CONTINUE
c 5904   FORMAT(28(1PE12.5))
c 5905   FORMAT(25(1PE12.5))
	CLOSE(21)
        CLOSE(22)
        CLOSE(23)
        CLOSE(31)
        CLOSE(32)
c        CLOSE(29)
c ------ dosw

        STOP
        END
