	SUBROUTINE GOPACROS(T,CAP,CSCA,CRC,CRS,CHC,CHS,CPC,CPS,L)
C   THIS SUBROUTINE CALCULATES AMONG OTHER THINGS:
C   CAP: TOTAL ABSORTIVE OPACITY
C   CSCA: TOTAL SCATERING OPACITY
C   CRC:  GRAPHITE ROSSELAND MEAN
C   CRS:  SILICATE ROSSELAND MEAN
C   CHC:  GRAPHITE FLUX MEAN
C   CHS:  SILICATE FLUX MEAN
C   CPC:  GRAPHITE PRESSURE MEAN
C   CPS:  SILICATE PRESSURE MEAN
C   NONE OF WHICH ARE ACTUALLY USED IN THE RADIATION TRANSFER, BUT ARE
C   CALCULATED ANYWAY TO MAKE NICE PLOTS.
	DIMENSION AX(25),AQX(100),MX(25),DAX(25),YEXT(25)
        DIMENSION CSCA(150),CAP(150),CAPEXT(150),CX(25),YSCA(25)
	DIMENSION CG(25),YP(25),CAFC(150),CAFS(150)
	COMMON/QUES/QEXT(150,100,2),QSCA(150,100,2),QPR(150,100,2)
	COMMON/ALAM/ALAMDA(83),ASTEPC,ASTEPSI,QAC(100),QASI(100)
	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
	COMMON/PHREQ/NF,FREQ(150),WF(150)
	COMMON/GEE/G(150),CPR(150),VOPAC
	COMMON/PICH/PI,C,AMH,UH,ENH
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/WTS/A(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     1	QSP(150,200),HHNU(150)
	ENH8 = ENH/1.0E+8
	DO 900 ICHEM = 1,2
	GO TO (910,920) ICHEM
C   LOAD GRAIN SIZE ARRAYS FOR LOOK-UP TABLE
910	ASTEP = ASTEPC
	DO 911 N=1,100
911	AQX(N) = QAC(N)
	DO 912 J=1,25
	CX(J)=CC(J,L)
912	CONTINUE
	NA = NC(L)
	GO TO 905
920	ASTEP = ASTEPSI
	DO 921 N=1,100
	AQX(N) = QASI(N)
921	CONTINUE
	DO 922 J=1,25
	CX(J)=CS(J,L)
922	CONTINUE
	NA = NS(L)
905	CONTINUE
C     FIND INTERPOLATION FACTOR
	DO 100 J=1,NA
	AX(J) = AG(ICHEM,J,L)
	IF(AX(J).LT.0.004) AX(J) = 0.004
	AXL = ALOG10(AX(J))
	MM = INT((AXL-AQX(1))/ASTEP)+1
	MX(J) = MM
	DAX(J) = (AXL-AQX(MM))/(AQX(MM+1)-AQX(MM))
100	CONTINUE
C    FREQUENCY LOOP
	DO 300 ILAM=1,NF
	INEW = 1+NF-ILAM
C    BIN LOOP
	DO 200 J=1,NA
        CEXT = 0.0	
	CSCAA = 0.0
	CG(J) = 0.0
        MM = MX(J)
	DD = DAX(J)
	CEXT =  QEXT(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QEXT(ILAM,MM,ICHEM)
	CSCAA = QSCA(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QSCA(ILAM,MM,ICHEM)
	CG(J) = +CEXT-((QPR(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*
     1	         QPR(ILAM,MM,ICHEM)))
	YEXT(J) = CEXT
	YSCA(J) = CSCAA
200	CONTINUE
C
C    END OF SIZE LOOP
C
	DO 205 J=2,NA
	A1 = PI*A(J-1)**2
	A2 = PI*A(J)**2
	YEXT(J-1) = ((YEXT(J)*A2)+(YEXT(J-1)*A1))*0.5
	YSCA(J-1) = ((YSCA(J)*A2)+(YSCA(J-1)*A1))*0.5
	YP(J-1)   = ((CG(J)*A2)+(CG(J-1)*A1))*0.5
205	CONTINUE
	CALL TWOTEG(AX,YEXT,SIG1,YSCA,SIG2,CX,NA)
	CALL TWOTEG(AX,YP,SIG3,YP,SIG4,CX,NA)
	GO TO (210,220) ICHEM
C   GRAPHITE
210		CAPEXT(ILAM) = SIG1*ENH8
		CSCA(ILAM) = SIG2*ENH8
		CAFC(ILAM)  = SIG3*ENH8
		G(ILAM) =  (SIG1+SIG2)*ENH8
		GO TO 300
220	CONTINUE
C   ADD SILICATE TO GRAPHITE
		CAPEXT(ILAM) = CAPEXT(ILAM) + SIG1*ENH8
		CPR(ILAM) = (SIG1 + SIG2)*ENH8
		CAFS(ILAM)  = SIG3*ENH8
		CSCA(ILAM) = CSCA(ILAM) + SIG2*ENH8
		CAP(ILAM) = CAPEXT(ILAM)-CSCA(ILAM)
300	CONTINUE	
C
C     END OF FREQUENCY LOOP
C
900	CONTINUE
C  MEAN OPACITIES
	GF1 = 3.288064E+15
	NX = NC(L)
	DO 9020 ICHEM = 1,2
	IF(ICHEM.EQ.2) NX = NS(L)
	DO 9020 IA=1,NX
	X1 = 157808.0/T
	CROC = 0.0
	CROS = 0.0
	CFC = 0.0
	CFSI = 0.0
	CPC = 0.0
	CPS = 0.0
	D2 = 0.0
	D3 = 0.0
	DO 9010 IF=1,NF
	IL = NF-IF+1
	XX = X1*FREQ(IF)/GF1
	EX = EXP(-XX)
	B = (XX**3)*EX/(1.0-EX)
	DBDT = XX*B/(1.0-EX)
	IF(G(IL).GT.0.0) THEN
	   CROC = CROC+(WF(IF)*FREQ(IF)*DBDT/G(IL))
	END IF
	IF(CPR(IL).GT.0) THEN
	   CROS = CROS+(WF(IF)*FREQ(IF)*DBDT/CPR(IL))
	END IF
	D2 = D2+WF(IF)*FREQ(IF)*DBDT
C     FLUX MEAN
	     CPS = CPS+WF(IF)*FREQ(IF)*XHNU(IF,L)*CAFS(IL)
	     CPC = CPC+WF(IF)*FREQ(IF)*XHNU(IF,L)*CAFC(IL)
	     CFC = CFC+WF(IF)*FREQ(IF)*XHNU(IF,L)*G(IL)
	     CFSI = CFSI+WF(IF)*FREQ(IF)*XHNU(IF,L)*CPR(IL)
	     D3   = D3+WF(IF)*FREQ(IF)*XHNU(IF,L)
9010	CONTINUE
	IF(CROC.NE.0) CRC = ALOG10(D2/CROC)
	IF(CROS.NE.0) CRS = ALOG10(D2/CROS)	
	IF(CFC.GT.0)  CHC = ALOG10(CFC/D3)
	IF(CFSI.GT.0) CHS = ALOG10(CFSI/D3)	
	IF(CPS.GT.0) CPS = ALOG10(CPS/D3)	
	IF(CPC.GT.0) CPC = ALOG10(CPC/D3)	
9020	CONTINUE
	RETURN
	END
