        program gridstep
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
C Program to step through the parameter array.
C This version contains a full parameter array for Brown Dwarfs
C Revised directory "tree" structure
C
C Grid Indicies
C   ips:         density = density(R_2)*(R/R_2)^(-powergd(ips))
C   il1,il2:  luminosity = alum1(il1)*10.00**alum2(il2)
C   it1,it2,it3:   t_eff = (tefgd1(it1)+0.1*tefgd2(i2))*10.0**(tefgd3(it3)) 
C   ior1,ior2,ior3   R_2 = outrgd1(ior1)*10.0**(10.0*outrgd2(ior2)+
C                                                          outrgd3(ior3))
C   iav1,iav2        A_V = avgd1(iav1)*10.0**avgd2(iav2)
C   iir1,iir2        R_1 = ainrgd1(iir1)*10.0**(10.0+ainrgd2(iir2))
C^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
        character*5 switch
        character*15 whyskip
        character*1 A
        character*19 rootdir
        logical mantles
C FULL GRID
        dimension powergd(5),alumgd1(3),alumgd2(6),tefgd1(3)
        dimension tefgd2(2),tefgd3(1),outrgd1(3),outrgd2(5)
        dimension outrgd3(1),avgd1(3),avgd2(3),ainrgd1(3)
        dimension ainrgd2(5)
c        data powergd/0.0,0.5,1.0,1.5,2.0/
c         data powergd/1.5,1.5,1.5,1.5,1.5/
c         data powergd/1.0,1.0,1.0,1.0,1.0/
c         data powergd/2.0,2.0,2.0,2.0,2.0/
c        data powergd/0.5,0.5,0.5,0.5,0.5/
        data powergd/0.0,0.0,0.0,0.0,0.0/
        data alumgd1/1.0,3.0,5.0/
        data alumgd2/-5.0,-4.0,-3.0,-2.0,-1.0,0.0/
        data tefgd1/1.0,2.0,3.0/
        data tefgd2/0.0,5.0/
        data tefgd3/3.0/
        data outrgd1/1.0,3.0,5.0/
        data outrgd2/1.0,2.0,3.0,4.0,5.0/
        data outrgd3/1.0/
        data avgd1/1.0,3.0,5.0/
        data avgd2/0.0,1.0,2.0/
        data ainrgd1/1.0,3.0,5.0/
        data ainrgd2/0.0,1.0,2.0,3.0,4.0/
C END FULL GRID
C *** begin mini-grid
c        dimension powergd(1),alumgd1(1),alumgd2(1),tefgd1(1)
c        dimension tefgd2(1),tefgd3(1),outrgd1(1),outrgd2(1)
c        dimension outrgd3(1),avgd1(3),avgd2(4),ainrgd1(3)
c        dimension ainrgd2(6)
c        data powergd/1.5/
c        data alumgd1/1.0/
c        data alumgd2/2.0/
c        data tefgd1/5.0/
c        data tefgd2/0.0/
c        data tefgd3/3.0/
c        data outrgd1/3.0/
c        data outrgd2/8.0/
c        data outrgd3/1.0/
c        data avgd1/1.0,3.0,5.0/
c        data avgd2/0.0,1.0,2.0,3.0/
c        data ainrgd1/1.0,3.0,5.0/
c        data ainrgd2/3.0,4.0,5.0,6.0,7.0,8.0/
C *** end mini-grid
        rootdir = 'envelope/wisrf/OH5/'
        open(unit=10,file='gostop.dat',type='unknown')
        open(unit=11,file='flowpart.dat',type='unknown')
        open(unit=12,file='directory.dat',type='unknown')
        read(10,*)switch
        if(switch.eq.'stop')goto 600
        close(10)
        read(11,*)nf,nfreq,ntcrek
        read(11,*)strms,teff,rstar,abh,abhe
        read(11,*)irorun,power,dens,dmdt,r1,r2
        read(11,*)i1,i2,i3,mantles,rmantle,tice
        read(11,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2
        rewind(11)
        sollum = alog10(3.826E33)
        sigma  = 5.66E-5
        pi     = 3.1415926
C Use capv = 217.687 for MRN (no ice) 
C Use capv = 210.5 for OH5 (with ice) 
C Use capv = 210.5 for OH2 (no ice)
c        capv   = 217.687
        capv   = 210.5
 10     continue
        open(unit=10,file='gostop.dat',type='unknown')
        whyskip = ' ' 
        istop = 0
c FULL GRID MAX INDEXES
C ipmax set equal to 1 to do only one density power law at a time.
        ipmax = 1
        il1max = 3
        il2max = 6
        it1max = 3
        it2max = 2
        it3max = 1
        ior1max = 3
        ior2max = 5
        ior3max = 1
        iav1max = 3
        iav2max = 3
        iir1max = 3
c        iir2max = 5
C iir2max set equal to iir2 as set in resetin so that
C   grid is started at the maximum index
        iir2max = 2
C MINI GRID MAX INDEXES
c        ipmax = 1
c        il1max = 1
c        il2max = 1
c        it1max = 1
c        it2max = 1
c        it3max = 1
c        ior1max = 1
c        ior2max = 1
c        ior3max = 1
c        iav1max = 3
c        iav2max = 4
c        iir1max = 3
c        iir2max = 6
        ips=ips+1
        if(ips.gt.ipmax)then 
             ips=1
             il1=il1+1
        end if
        if(il1.gt.il1max)then
             il2 = il2+1
             il1 = 1
        end if
        if(il2.gt.il2max)then
             it1 = it1+1
             il2 = 1
        end if
        if(it1.gt.it1max)then 
             it2 = it2 + 1
             it1 = 1
        end if
        if(it2.gt.it2max)then 
             it3 = it3 + 1
             it2 = 1
        end if
        if(it3.gt.it3max)then 
             ior1 = ior1 + 1
             it3 = 1
        end if
        if(ior1.gt.ior1max)then 
             ior2 = ior2 + 1
             ior1 = 1
        end if
        if(ior2.gt.ior2max)then 
             ior3 = ior3 + 1
             ior2 = 1
        end if
        if(ior3.gt.ior3max)then 
             iav1 = iav1 + 1
             ior3 = 1
        end if
        if(iav1.gt.iav1max)then 
             iav2 = iav2 + 1
             iav1 = 1
        end if
        if(iav2.gt.iav2max)then 
             iir1 = iir1 + 1
             iav2 = 1
        end if
        if(iir1.gt.iir1max)then 
             iir2 = iir2 + 1
             iir1 = 1
        end if
        if(iir2.gt.iir2max)then
            istop = 1
            whyskip = ' End of Run '
            goto 100 
        end if
        power = powergd(ips)
        alum1 = alumgd1(il1)
        alum2 = alumgd2(il2)
        alum  = alum1*(10.00**alum2)
        tef1  = tefgd1(it1)
        tef2  = tefgd2(it2)
        tef3 =  tefgd3(it3)
        teff =  (tef1+0.1*tef2)*(10.00**(tef3))
        alt = alog10(alum)+sollum-(4.0*alog10(teff))
        rstar = sqrt(10.0**(alt)/(4.0*pi*sigma))
        outr1  =  outrgd1(ior1)
        outr2  =  outrgd2(ior2)
        outr3  =  outrgd3(ior3)
        r2   = outr1*10.00**(10.0*outr3+outr2)
        av1    =  avgd1(iav1)
        av2    =  avgd2(iav2)
        av     = av1*(10.00**av2)
        air1   =  ainrgd1(iir1)
        air2   =  ainrgd2(iir2)
        r1   = air1*10.00**(10.0+air2)
        tr1  =  1200.0*((alum/1.0E3)**(1.0/4.0))/sqrt(r1/1.0E14)
        if(rstar.ge.r1)then
           istop = 2
           whyskip = ' rstar > r1'
        else if(tr1.gt.3.0e3)then
           istop = 2
           whyskip = ' T(R1) > 3000'
       else if(it1.eq.1.and.it2.eq.1)then
           it1 = it1+1
           ips = ips -1
           istop =2
           whyskip = ' teff grid'
       else if(it1.eq.3.and.it2.eq.2)then
           it1 = it1+1
           ips = ips -1
           istop =2
           whyskip = ' teff grid'
       else if(il1.eq.1.and.il2.eq.1)then
           il1 = il1+1
           ips = ips -1
           istop =2
           whyskip = ' L too low'
       else if((r2/r1).lt.10.0)then
               ior1 = ior1 + 1
               ips = ips - 1
               istop = 2
               whyskip = ' r2/r1 < 10'
       else if(r1.gt.r2)then
               ior1 = ior1 + 1
               ips  = ips  - 1
               istop=2
               whyskip = ' r2 < r1'
        else if(r2.lt.1.0E11)then
               ior1 =ior1 + 1
               ips = ips - 1
               istop=2
               whyskip = ' r2 < 10^11'
        else if(r2.gt.1.0E16)then 
              ior1 = ior1+1
              ips = ips - 1
              istop=2
              whyskip = ' r2 > 10^16'
        else if(r1.eq.r2)then
              ior1 = ior1+1
              ips = ips - 1
              istop=2
              whyskip = ' r1 = r2'
        end if
 100    continue
        if(istop.eq.0)then
        if(power.eq.1.0)then
           arr = power*alog10(r2)+alog10(alog(r2)-alog(r1))
           arr = 10.00**(arr)
        else
           arr =r1*(r2/r1)**power*((r2/r1)**(-power+1.0)-1.0)
     &          /(-power+1.0)
        end if
        dens = av/(1.0857*capv*arr)
        if(dens.lt.1.0E-21)then
               istop=2
               whyskip=' dens too small' 
        endif
        end if
        if(istop.eq.0)switch = ' go  '
        if(istop.eq.1)switch = ' stop'
        if(istop.eq.2)switch= ' skip'
        write(10,*)switch
        close(10)
        A = 'a'
        write(6,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2,switch,whyskip
         if(istop.eq.2)goto 10 
          ntcrek = 12
          if(av.gt.1.0E2)ntcrek=15
c         write(6,555)A,int(power),int(mod(power,1)*10),int(alum1),
c     &        int(alum2),int(tef1),int(tef2),int(tef3),int(outr1),
c     &        int(outr3),int(outr2),int(av1),int(av2),int(air1),
c     &        int(air2)
c 555     format(A1,14I1)
c         write(12,555)A,int(power),int(mod(power,1)*10),int(alum1),
c     &        int(alum2),int(tef1),int(tef2),int(tef3),int(outr1),
c     &        int(outr3),int(outr2),int(av1),int(av2),int(air1),
c     &        int(air2)
        write(6,560)rootdir,power,alum,teff,r2,av,r1
        write(12,560)rootdir,power,alum,teff,r2,av,r1
 560    format(A19,'D-',F3.1,'/L',1PE8.2,'/T',1PE8.2,'/O',1PE8.2,
     &       '/A',1PE8.2,'/I',1PE8.2)
        write(11,*)nf,nfreq,ntcrek
        write(11,*)strms,teff,rstar,abh,abhe
        write(11,*)irorun,power,dens,dmdt,r1,r2
        write(11,*)i1,i2,i3,mantles,rmantle,tice
        write(11,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2,switch,whyskip
 600    continue
        close(11)
        close(12)
        stop
        end

