        SUBROUTINE RADTRN
C Straight version of radtrn which calculates Tdust
C Outputs are r,ro,<T_si>,dtemp
C Inensities are output in program flowmout (radtrn2.f, sphrset2.f)
        INTEGER PINDEX
        COMMON/INTRG/ II,III,NFREQ
        COMMON/ATMSP/ TEMP(200),DENST(200)
        COMMON/RT/ CA(150,200),CASC(200),CROSS(200)
        COMMON/CCCC/ CROSC,CPLKC
        COMMON/RT2/ CANU(200)
        COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     A              QSP(150,200),HHNU(150)
        COMMON/CASES/ ITER,NTCREK
        DIMENSION CSCA(150),CAP(150)
        COMMON/BCREK/ AJ(200),AH(200),AK(200),CPLNK(200)
        COMMON/IMPACT/ TERP(200),NUED,IIIED
        COMMON/CONSTS/ SIG1,C,PI
        COMMON/PHREQ/ NF,FREQ(150),WF(150)
        COMMON/FRAC/ P(200),R(300),NR,NP,PINDEX(200)
        COMMON/REAL/ HZORSQ,TEFF
        COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
        COMMON/DUST3/STRFLD(200),TAUNU(200),PTHAU(200)
        COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),
     1         DTEMP(2,25,200),DPLNK(2,25,200),DCHIJ(2,25,200)
        COMMON/DUST5/DBSORC(150,200)
        COMMON/FCTRS/FHJTOT,FKJTOT(200),CHIJ(200),CHIF(200),QSPTOT(200),
     1               CHFT(200)
        COMMON/WTS/AC(25),CC(25,200),CS(25,200),CONST(2,25)
        COMMON/SILICATE/AS(25),YC1(25),YSI1(25)
        COMMON/FFR/NTCRR  
        COMMON/DISK/STRT(150),DIT(150)
        COMMON/MINDEX/ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2
        COMMON/BCS/AVHBC
        DIMENSION DCACA(150,25),DCASA(150,25)
        DIMENSION S(200),XJSAV(200),TMEAN(200),SIT(200)
        DIMENSION AVJ(200),AVH(200),AVK(200),SNU(200),CANUSG(200)
        DIMENSION Y1(25),Y2(25),C1(25),C2(25)
        DIMENSION CAPEXT(150,200),CANUEX(200),TAUEXT(200)
        DIMENSION CANUT(200),CSSAVE(25)
        WRITE(11,1000)HZORSQ
1000    FORMAT(1X,'FROM RADIATION TRANSFER    HZ0RSQ=',E14.6)
        NR=III
        IIIED=III
        INUVIS = 75
C
C  SUBROUTINE SPHRSET DEFINES THE IMPACT PARAMETERS FOR SUBROUTINE SPHERE
C  TYPICALLY ABOUT 6 RAYS HIT THE CORE.  BEYOND THE CORE THERE IS ONE RAY
C  FOR EVERY THIRD RADIUS VALUE OF R.  ALSO IN SPHERE TAU IS DEFINED FOR
C  USE IN INTERPOLATION OF THE EDDINGTON FACTORS INSIDE SPHERE USING TERP
C
        CALL SPHRSET
C    
        WRITE(6,1500) ITER,NFREQ,NP
1500    FORMAT(' ITER,NFREQ,NP',3I5)
        FHJTOT = 0.5
        DO 150 NU=1,NFREQ
        DO 130 I=1,III
        SIT(I) = 900.0
C   SIT = AVERAGE SILICATE TEMPERATURE
130     FKJ(NU,I)=1.0/3.0
150     FHJ(NU)=0.5    
        DO 5 IA = 1,25
        CSSAVE(IA) = CS(IA,III)
 5      CONTINUE
C
C  NTCREK CONTROLS THE NUMBER OF TEMPERATURE CORRECTIONS
C
C  START TEMPERATURE CORRECTION LOOP
C
      DO 600 NTCRR=1,NTCREK
      WRITE(11,1700) NTCRR,NTCREK
1700  FORMAT(' NTCRR,NTCREK',2I5)
C   LOAD OPACITIES
        DO 100 I=1,III
           TX=TEMP(I)           
              DO 15 IA = 1,25
              IF(SIT(I).GT.1000.0) THEN
                  CS(IA,I) = 1.0E-4*CSSAVE(IA)
              ELSE
                  CS(IA,I) = CS(IA,III)
              END IF
15            CONTINUE
           CALL GOPAC(TX,CAP,CSCA,DCACA,DCASA,I)
	   CASC(I) = CSCA(5)
           DO 50 NU=1,NF
	   DCASC(NU,I) = (1.0-GMIE(NU,I))*CSCA(NU)
	   DO 25 IA=1,25
           DCAPCA(NU,IA,I) = DCACA(NU,IA)
	   DCAPSA(NU,IA,I) = DCASA(NU,IA)
25	   CONTINUE
 	   CA(NU,I) = CAP(NU)+DCASC(NU,I)
           CAPEXT(NU,I)=CAP(NU)+CSCA(NU)
50        CONTINUE
           CROSS(I)=CROSC
           CPLNK(I)=CPLKC
100     CONTINUE
C    LOAD THERMAL EMISSIVITY 
   	DO 125 I=1,III
	DO 125 NU=1,NF
	CALL DSORCE(I,NU,DBSORC(NU,I))
125	CONTINUE
C
C     INITIALIZE MOMENTS J,H,AND K  AND MEAN OPACITIES TO ZERO
C
      DO 175 I=1,III
      AJ(I)=0.
      AH(I)=0.
      AK(I)=0.
      CHIJ(I)=0.
      CHFT(I)=0.
      AVHBC = 0.0
      CANUEX(I)=CAPEXT(INUVIS,I)
      CANUT(I) = CAPEXT(INUVIS,I)*DENST(I)
      DO 175 IA = 1,25
      DO 175 ICHEM = 1,2
      DCHIJ(ICHEM,IA,I) = 0.
175   CONTINUE
C CALCULATE TOTAL VISUAL EXTINCTION
      CALL TAUSCL(CANUEX,DENST,R,TAUEXT,III)
c      CALL ONETEG(R,CANUT,AV,III)
      AV=1.0857*TAUEXT(III)
c      AV=1.0857*AV
C
C   START FREQUENCY LOOP
C
      DO 525 NU=1,NFREQ
C   ITRAD AND NRADMX CONTROL THE NUMBER OF ITERATIONS ON THE EDDINGTON
C   FACTOR AT ANY FREQUENCY
C   ITRAD  =  MINIMUM NUMBER OF ITERATIONS
C   NRADMX = MAXIMUM NUMBER OF ITERATIONS          
        ITRAD  = 2     
        NRADMX = 7
        NUED=NU
        WFF=WF(NU)
        DO 200 I=1,III
        CANU(I)=CA(NU,I)
        CANUEX(I)=CAPEXT(NU,I)
 200    CONTINUE
C  CALCULATE THE MONOCHROMATIC RADIAL OPTICAL DEPTH
      CALL TAUSCL(CANU,DENST,R,TAUNU,III)
      CALL TAUSCL(CANUEX,DENST,R,TAUEXT,III)
C  START EDDINGTON FACTOR LOOP
      NED=0
250   NED=NED+1
C
C     SUBROUTINE VAREDQ SOLVES FOR JNU VS R GIVEN THE CURRENT GUESS FOR
C     THE EDDINGTON FACTOR FKJ AND FHJ AND THE CURRENT GUESS FOR THE
C     TEMPERATURE DISTRIBUTION IN THE ATMOSPHERE
C
      CALL VAREDQ(NU)
C
      DJMAX=0.
      IF(NED-1) 350,350,275
C
C        COVERGENCE TEST TO SEE IF THE EDDINGTON FACTOR HAS BEEN ITERATED ON 
C        ENOUGH
C
275    DJMAX=0.
       DO 300 I=1,III
       XJJ=XJNU(NU,I)
       DJ=ABS(XJJ-XJSAV(I))/ABS(XJJ+1.0E-15)
       IF(DJ.GT.DJMAX) DJMAX=DJ
300    CONTINUE
       CONVRG=1.0E-3
       IF(NED-ITRAD)350,325,400
325    IF(DJMAX.GT.CONVRG) ITRAD=ITRAD+1
C      WRITE(6,1900)NU,NED,ITRAD,DJMAX
1900   FORMAT(' NU,NED,ITRAD,DJMAX',3I5,E12.4)
C         END CONVERGENCE TEST
C
      IF(NED.GE.NRADMX) GO TO 400
      IF(NED.GE.ITRAD)  GO TO 400
350   CONTINUE
      DO 375 I=1,III
375   XJSAV(I)=XJNU(NU,I)
C
C     SUBROUTINE SPHSORC OBTAINS THE SOURCE FUNCTION, JBC, AND HBC FOR SPHERE
C
           CALL SPHSORC(NU,CANUSG,SNU)
C
C     SUBROUTINE SPHERE SOLVES THE FORMAL TRANSFER EQUATION ALONG A LARGE
C     NUMBER OF RAYS WHICH ARE DEFINED BY THEIR IMPACT PARAMETER.
C     NOTE: THERE ARE NP IMPACT PARAMETERS - SPHERE CALCULATES THE 
C     EDDINGTON FACTOR AT NP RADII AND THE MOMENTS J,H,AND K WHICH ARE
C     IDENTIFIED IN THE PROGRAM AS AVJ,AVH,AND AVK
C
              CALL SPHDUST(III,SNU,CANUSG,AVJ,AVH,AVK)
C
        GO TO 250
C
C     END OF EDDINGTON FACTOR LOOP
C
400     CONTINUE
        AMBDA=3.0E+14/FREQ(NU)
        XAMBDA=ALOG10(AMBDA)

       CALL ISRFSUB(FREQ(NU),NU,AIMINUS)
       AVHBC = AVHBC + WFF*FREQ(NU)*0.25*AIMINUS

C   XHNU is always net flux H+ - H- 
C   Output is net (not H+) which subtracts background radiation
C   For nu x L_nu  = nu x (4 pi R)^2 H+ use:
c        ELNU=2.*(ALOG10(4.*PI*R(III)))+
c     .       ALOG10(XHNU(NU,III)+0.25*AIMINUS+1.0E-32)+
c     .       ALOG10(FREQ(NU))
C    
C   For nu x L_nu  = nu x (4 pi R)^2 ( H+ - H- )use:
        IF (XHNU(NU,III) .GT. 0.0) THEN
           ELNU=2.*(ALOG10(4.*PI*R(III))) +
     .        ALOG10(XHNU(NU,III))+ALOG10(FREQ(NU))
        ELSE
           ELNU= 5.0+ALOG10(FREQ(NU))
        END IF
        WRITE(11,2000)TAUEXT(III),FREQ(NU),AMBDA,XAMBDA,ELNU
2000    FORMAT(' TAU,FRQ,LAMDA,LOG(LAMDA,NULNU)',5E13.5)

c -------- dosw
	IF (NTCRR .EQ. NTCREK) THEN
	   IF (NU .EQ. 1) THEN
	      WRITE(21,*) '   Freq Av Fnu Tau Lnu Lambda Fnus '
              WRITE(21,*)' NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC 
     & NUMERIC NUMERIC '
              WRITE(21,*)' [Hz] [mag] [erg/cm2/s/Hz]  []  [erg/s/Hz]  
     & [mu]  [erg/cm2/s/Hz] '
	   END IF
	   XXXX = MAX(ELNU - ALOG10(FREQ(NU)),5.0)
C FLUXP = F+, FLUXN = F+ - F-. If FLUXN < 0 then absorbption agains ISRF
           FLUXP = 4.0*PI*(XHNU(NU,III)+0.25*AIMINUS)
           FLUXN = 4.0*PI*(XHNU(NU,III))
           IEAV = 1
           IF(FLUXN.LT.0) THEN
              IEAV = 0
           END IF 
           ZZZZ = STRFLD(1)*(R(1)/R(III))**2*4.0*PI
           WRITE(21,2005)FREQ(NU),AV,MAX(FLUXN,1.0e-28),TAUEXT(III),
     &        XXXX,AMBDA,ZZZZ
2005       FORMAT(' ',1PE11.3,1PE11.3,5(1PE11.3))
	END IF
c -------- dosw

C
C   HERE ARE FOUND TOTAL J,H,AND K BY SUMMING OVER JNU,HNU,AND KNU OVER
C   ALL FREQUENCIES
      DO 500 I=1,III
      AJ(I)=AJ(I)+WFF*FREQ(NU)*XJNU(NU,I)
      AH(I)=AH(I)+WFF*FREQ(NU)*XHNU(NU,I)
      AK(I)=AK(I)+WFF*FREQ(NU)*FKJ(NU,I)*XJNU(NU,I)
C  NOTE : CHIJ = INTEGRAL(JNU*CAP(abs)*NU)dln(NU)
C         CHFT = INTEGRAL(HNU*CAP(abs+(1-g)sca)*NU)dln(NU)
      CAPABS = (CA(NU,I)-DCASC(NU,I))
      CHIJ(I)=CHIJ(I)+WFF*FREQ(NU)*XJNU(NU,I)*CAPABS
      CHFT(I)=CHFT(I)+WFF*FREQ(NU)*XHNU(NU,I)*CANU(I)
      DO 475 ICHEM = 1,2
         IF(ICHEM.EQ.1) THEN
            DO 425 IA=1,25
425         DCHIJ(ICHEM,IA,I)=DCHIJ(ICHEM,IA,I)+WFF*FREQ(NU)*
     1                        XJNU(NU,I)*DCAPCA(NU,IA,I)
	 ELSE
            DO 450 IA=1,25
450         DCHIJ(ICHEM,IA,I)=DCHIJ(ICHEM,IA,I)+WFF*FREQ(NU)*
     1                        XJNU(NU,I)*DCAPSA(NU,IA,I)
         END IF
475      CONTINUE
500   CONTINUE
      IF(ITRAD.GT.NRADMX) ITRAD=NRADMX
525    CONTINUE
C     END FREQUENCY LOOP
        FHJTOT = (AH(III)+2.0*AVHBC)/AJ(III)
c        FHJTOT = AH(III)/AJ(III)
        write(6,*)'FHJTOT,AJ,AH,AK,AVHBC',FHJTOT,AJ(III),AH(III),
     .               AK(III),AVHBC

C   TEMPERATURE CORRECTION FROM BCREK
        CALL DBCREK
C   UPDATE PLANCK MEAN OPACITY WITH NEW TEMPERATURE
        DO 550 I=1,III
        CALL BMEAN(I)		
550     CONTINUE                    
C   UPDATE THERMAL EMISSIVITY WITH NEW TEMPERATURE  
        DO 575 I=1,III
        DO 575 NU=1,NF
	CALL DSORCE(I,NU,DB)
	DBSORC(NU,I) = DB
575     CONTINUE	
C
C   FIND ENERGY WEIGHTED MEAN T  (SILICATE ONLY) =
C    INTEGRAL [ n(a)Qb(pi*a**2)T**4 da]/ INTEGRAL [ n(a)Qb(pi*a**2) da]**.25
        DO 590 IR = 1,III
	DO 580 IA=2,25
        IM = IA - 1
        C1(IM) = CC(IM,IR)
        C2(IM) = CS(IM,IR)
	AS1 = DPLNK(2,IA,IR)*DTEMP(2,IA,IR)**4
	AS2 = DPLNK(2,IA-1,IR)*DTEMP(2,IA-1,IR)**4
580	Y2(IA-1) = 0.5*(AS1+AS2)
	CALL TWOTEG2(AC,Y1,B1,25,C1,AC,Y2,B2,25,C2)
	DNUM = B2
C	WRITE(6,*)'B1+B2',DNUM
	DO 585 IA=2,25
	AS1 = DPLNK(2,IA,IR)
        AS2 = DPLNK(2,IA-1,IR)
585	Y2(IA-1) = 0.5*(AS1+AS2)
        CALL TWOTEG2(AC,Y1,B1,25,C1,AC,Y2,B2,25,C2)
	DNOM = B2
 	SIT(IR) = (DNUM/DNOM)**0.250
590     CONTINUE 
C     FIND ERROR IN FLUX CONSERVATION
C     DELERR = ALLOWED FRACTIONAL ERROR IN FLUX
        DELERR = 0.06
        DELMAX = 0.0
        DO 625 I=1,III
	IF(AH(I).LT.1.0E-30)AH(I) = 1.0E-30
	AHRSQ = 2.0*ALOG10(R(I))+ALOG10(AH(I))
	AHT    = 2.0*ALOG10(R(1))+ALOG10(HZORSQ)
	DEL = 10.00**(AHRSQ-AHT)-1.0
        IF(ABS(DEL).GT.ABS(DELMAX).and.I.gt.15)DELMAX = DEL
	WRITE(6,2500)I,NTCRR,AHRSQ,AHT,DEL,CHFT(I)
2500    FORMAT(' I,NTCRR,AHRSQ,HRSQ,DEL,KF',2I4,5E13.5)
625	CONTINUE
C   IF ERROR IS LESS THAN DELERR THEN TRANSFER OUT OF TEMPERATURE LOOP 
C   SKIP THIS STEP UNTIL LOGIC IS CORRECTED, IF TRANSFER OUT OF LOOP THEN
C   OUTPUT IS NOT PRINTED CORRECTLY
600     CONTINUE
605     CONTINUE
        WRITE(6,*) 'END OF TEMPERATURE CORRECTION LOOP'
        IF(ABS(DELMAX).GT.DELERR)THEN
             OPEN(UNIT=27,STATUS='UNKNOWN',FILE='failed.out')
             WRITE(27,*)ips,il1,il2,it1,it2,it3,
     &  ior1,ior2,ior3,iav1,iav2,iir1,iir2,' FAILED-flowm ',delmax
        END IF
C     END OF TEMPERATURE CORRECTION LOOP
C  FIND MEAN TEMPERATURE AT ALL RADII AND CALCULATE NEW ROSSELAND MEANS
	DO 650 IT = 1,III
c	CALL MEANT(IT,TMEAN(IT))
C SET TEMPERATURE FOR PRINTOUT EQUAL TO MEAN SILICATE TEMPERATURE
        TEMP(IT)=SIT(IT)
c        TEMP(IT)=TMEAN(I)
c        CALL GOPAC(TMEAN(IT),CAP,CSCA,DCACA,DCASA,IT)
c        CROSS(IT)=CROSC
650	CONTINUE

C -----------------  DOSW
c  NOTE: Seemingly erroneous values may be output if you attempt to
c  print too much on a line.  Here we only print T for 2 of the 25 grain
c  sizes.
C  OUTPUT FINAL DUST TEMPERATUES
c         WRITE(25,*) 'R T_C T_C T_Si T_Si'
c	 WRITE(25,*) 'NUMERIC NUMERIC NUMERIC NUMERIC NUMERIC' 
c	 WRITE(25,8877) (AC(K),K=1,25,24),(AS(K),K=1,25,24)
c8877	 FORMAT('[cm]',' ',4(1X,'[',F5.3,']'))
c	 DO 675 I = 1,III,2
c      	 write(25,8989) R(I),(DTEMP(1,K,I), K=1,25,24),
c     +       (DTEMP(2,K,I), K=1,25,24)
c8989	  FORMAT(' ',1PE10.3,4(1X,E9.2))
c 675     CONTINUE
      RETURN
      END







