      SUBROUTINE SPLRAD(N,TAU,S,R,H,IPLUS,IMINUS,SYM)
C Revised for incident ISRF
      IMPLICIT DOUBLE PRECISION (A-H,O-R,T-Y)
      LOGICAL SYM
      REAL IPLUS,IMINUS
      COMMON/CASES/ ITER,NTCREK
      COMMON/FFR/NTCRR
      DIMENSION TAU(200),S(200),R(200),D(200),H(200)
C     USE SPLINE EQUATIONS TO SOLVE THE TRANSFER EQUATION WITH S GIVEN

C     START FORWARD ELIMINATION
C     UPPER BOUNDARY
C  Spline based difference equation for dU/dTau at upper boundary
C  dU/dTau = U = alfa*U + beta = -M0*H0/2 - (U0-Up)/H0 + (M0-Mp)*H0/6
C      Where     H0 = Tau(2)-Tau(1)
C		 U0 = U at Tau(1)
C		 Up = U at Tau(2)
C		 M0 = Second derivative at Tau(1) = U(1) - S(1)
C		 Mp = Second derivative at Tau(2) = U(2) - S(2)
C  Tri diagnal form:
C  U0*(alfa + H0/3 + 1/H0) - Up*(1/H0 - H0/6) = -beta + S(1)*H0/3 +S(2)*H0/6
C      --------B---------        -----C----- 
      H0=(TAU(2)-TAU(1))
      C=1./H0-H0/6.
      B=1./H0+H0/3.+1.
      D(1)=C/B
      R(1)=((H0*(2.*S(1)+S(2))/6.)+IMINUS)/B

C     NORMAL DEPTH POINT
      NM1=N-1
      DO 1 I=2,NM1
        HM1=H0
        H0=(TAU(I+1)-TAU(I))
        A=H0*(1.-(HM1**2.)/6.)
        B=(H0+HM1)*(1.+H0*HM1/3.)
        C=HM1*(1.-(H0**2.)/6.)
        X=1./(B-A*D(I-1))
        D(I)=X*C
        R(I)=X*(H0*HM1/6.)*(HM1*S(I-1)+2.*(H0+HM1)*S(I)+H0*S(I+1))
     .       +X*A*R(I-1)
    1 CONTINUE

C     LOWER BOUNDARY
C  Spline based difference equation for dU/dTau at boundary:
C  dU/dTau = I - U = alfa*U + beta = M0* H0/2 + (U0-Um)/H0 -(M0-Mm)*H0/6
C      Where         H0 = Tau(N)-Tau(N-1)
C		     U0 = U at Tau(N)
C		     Um = U at Tau(N-1)	
C                    M0 = Second derivative at Tau(N) =   U(N) - S(N)
C		     Mm = Second derivative at Tau(N-1) = U(N-1) - S(N-1)
C Tri diagonal form:
C -Um*(1/H0 - H0/6) + U0(-alfa + 1/H0 + H0/3) = beta + S(N)*H0/3 + S(N-1)*H0/6
C      -----A-----               -----B-----
      A=1./H0-H0/6.
      B=1./H0+H0/3.
      R0=A*R(N-1)
      IF(SYM) GO TO 2
      B=B+1.
C     B = B - alfa
      R0=R0+IPLUS
 2    CONTINUE
      R(N)=(R0+H0*(2.*S(N)+S(N-1))/6.)/(B-A*D(N-1))

C     END FORWARD ELIMINTATION
C
C     START BACKWARD SUBSTITUTION
      DO 3 II=1,NM1
      I=N-II
      R(I)=R(I)+D(I)*R(I+1)
    3 CONTINUE
C     END BACKWARD SUBSTITUTION
C
C     FIND H=0.5*(I(MU)-I(-MU)) = MU*DR/DTAU
      H(1)=R(1)-IMINUS
      DO 4 I=2,N
      H0=TAU(I)-TAU(I-1)
      H(I)=(R(I)-R(I-1))/H0+H0*(R(I-1)-S(I-1)+2.*(R(I)-S(I)))/
     .     (6.)
    4 CONTINUE
C     WRITE(11,840)H(1),R(1),H(NM1),R(NM1),IPLUS
C  840 FORMAT(' H1,R1,H(NM1),R(NM1),IPLUS',5E13.5)
      RETURN
      END
